using System;
using System.Collections.Generic;
using System.Text;
using JetBrains.ReSharper.Psi;
using JetBrains.ReSharper.UsageHightlighting;

namespace AccessibilityAnalayzer
{
    public class AccessibilityHighlightEntry : UsageHighlightingEntry
    {
        private AccessibilityHighlightEntryUserData accessibilityHighlightEntryUserData;

        internal AccessibilityHighlightEntry(DocumentRange range, UsageHighlightingType usageHighlightingType, AccessibilitySuggestion accessibilitySuggestion, IDeclaredElement declaredElement,IDeclaration declaration)
            : base(range, usageHighlightingType)
        {
            accessibilityHighlightEntryUserData = new AccessibilityHighlightEntryUserData(accessibilitySuggestion, declaredElement,declaration);
        }

        internal AccessibilityHighlightEntryUserData AccessibilityHighlightEntryUserData
        {
            get { return accessibilityHighlightEntryUserData; }
        }
    }
    
    internal class AccessibilityHighlightEntryUserData
    {
        private readonly AccessibilitySuggestion accessibilitySuggestion;
        private readonly IDeclaredElement declaredElement;
        private readonly IDeclaration declaration;

        public AccessibilityHighlightEntryUserData(AccessibilitySuggestion accessibilitySuggestion, IDeclaredElement declaredElement,IDeclaration declaration)
        {
            this.accessibilitySuggestion = accessibilitySuggestion;
            this.declaredElement = declaredElement;
            this.declaration = declaration;
        }

        public AccessibilitySuggestion AccessibilitySuggestion
        {
            get { return accessibilitySuggestion; }
        }

        public IDeclaredElement DeclaredElement
        {
            get { return declaredElement; }
        }

        public IDeclaration Declaration
        {
            get { return declaration; }
        }
    }
}
