using System;
using System.Collections.Generic;
using System.Text;
using JetBrains.ReSharper;
using JetBrains.ReSharper.Editor;
using JetBrains.ReSharper.ProjectModel;
using JetBrains.ReSharper.Psi;
using JetBrains.ReSharper.Psi.CSharp;
using JetBrains.ReSharper.TextControl;
using JetBrains.ReSharper.UsageHightlighting;

namespace AccessibilityAnalayzer
{
    internal sealed class AccessibilityHighlightingRangeEvaluatorFactory
    {
        private AccessibilityHighlightingRangeEvaluatorFactory()
        {
        }

        public static IHighlightingRangeEvaluator CreateHighlightingRangeEvaluator(ISolution solution, ITextControl textControl, IProjectModelElement projectModelElement)
        {
            IProjectFile file1 = DocumentManager.GetInstance(solution).GetProjectFile(textControl.Document);
            if (file1 == null)
            {
                return null;
            }
            IDeclaredElement element1 = TextControlToPsi.GetContainingTypeOrTypeMember(solution, textControl);
            if (element1 == null)
            {
                return null;
            }
            return new AccessibilityHighlightingRangeEvaluator(element1, file1, solution,projectModelElement);

        }

        
    }
}
